<?php
// script to prevent when exterior temperature become inferior or superior to interior one
class etage_temperature_int_ext extends hook
{
	public $hookName = "etage_temperature_int_ext";
	public $active = false;			//enable/disable hook (true => enabled)
	public $tempSup = 25;
	public $tempInf = 20;


	protected $devicelist = array(
		METEO=> "tempc",
	);

	protected $portesList = array(
		ETAGE_BUREAU_FENETRE => "contact",
		ETAGE_CHAMBRE_FENETRE => "contact",
		ETAGE_SALON_FENETRE => "contact",
		ETAGE_CUISINE_FENETRE => "contact",
		ETAGE_PORTE_FENETRE => "contact"
	);

	protected $paires = array(
		ETAGE_BUREAU_TEMP => ETAGE_BUREAU_FENETRE,
		ETAGE_SALON_TEMP => ETAGE_SALON_FENETRE,
		ETAGE_SALON_TEMP => ETAGE_PORTE_FENETRE,
		ETAGE_CHAMBRE_TEMP => ETAGE_CHAMBRE_FENETRE
	);

	function installHooks(&$indexDevices)
	{
		return $this->installHooksFunction($indexDevices);
	}

	// callback fonction. Is called with these 4 parameters
	public function callBack(&$device, $property, $value)
	{
		global $indexDevices, $hooks;
		static $time;
		$portes = array();
		$status = -1;
		$msg = "";
		if ($this->active)
		{
			logger(DEBUG, _("etage_temperature_int_ext hook"), null ,$device);

			if (empty($time))	$time = now();
			if ((now()->format("U") - $time->format("U")) > 300)
			{

				$indoorTemp = $device->properties["indoortempc"]["value"];


				if ( $value > $indoorTemp)
				{
					if( ($indoorTemp <= $this->tempSup) and empty($portes))
					{
						$status = 1;
						//logger(ALERT, _("Open doors to climate"), null ,$device);
					}elseif($indoorTemp >= $this -> tempSup and ! empty($portes))
					{
						$status = 0;
						//logger(ALERT, _("Close doors to climate"), null, $device);
					}
				}elseif ( $value < $indoorTemp )
				{
					if (($indoorTemp >= $this->tempSup) and empty($portes) )
					{
						$status = 1;
						//logger(ALERT, _("Open doors to climate"), null ,$device);
					}elseif ($indoorTemp <= $this->tempSup)
					{
						$status = 0;
						//logger(ALERT, _("Close doors to climate"), null, $device);
					}
					logger (INFO, sprintf(_("%s: notification received from MQTT from %s => parameter: %s value: %s"), $this->hookName, $device->friendlyName, $property, bool2string($value)), __FILE__ . ":" . __LINE__, $device);
				}
				print_r($portes);
				if ($status == 1)
				{
					$portes = $hooks["test_portes"]->testPortes($this->portesList, false, false);
					if (empty($portes))
					{
						$time = now();
						foreach($portes as $porte)
						{
							$msg .= $porte . "\n";
						}
						logger(ALERT, _("Open doors to climate") . $msg, null, $device);
					}
				}else
				{
					$portes = $hooks["test_portes"]->testPortes($this->portesList, false, true);
					if (!empty($portes))
					{
						$time = now();
						foreach($portes as $porte)
						{
							$msg .= $porte . "\n";
						}
						logger(ALERT, _("Close doors to climate\n") . $msg, null, $device);
					}
				}
			}
		}else
		{
			logger(DEBUG, _("etage_temperature_int_ext hook is inactive"), null ,$device);
		}
	}
}
$hooks["etage_temperature_int_ext"] = new etage_temperature_int_ext();
?>
